Subject: bug#23008: closed (Re: bug#23008: Daylight Savings Time Bug in Date)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 14 Mar 2016 15:05:02 +0000

Your bug report

#23008: Daylight Savings Time Bug in Date

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
23008: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=23008
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#23008: Daylight Savings Time Bug in Date
From: Eric Blake <[email-masked]>
To: Sarah Corriher <[email-masked]>, [email-masked], GNU bug control <[email-masked]>
Date: Mon, 14 Mar 2016 09:04:16 -0600
List-Id: <debbugs-submit.debbugs.gnu.org>

tag 23008 notabug
thanks

On 03/13/2016 11:24 PM, Sarah Corriher wrote:
> We detected a bug in the date program, which correlates to the daylight
> savings time change.

Thanks for the report.  However, this is not a bug, but a FAQ that gets
asked twice a year.  See:

https://www.gnu.org/software/coreutils/faq/coreutils-faq.html#The-date-command-is-not-working-right_002e

> 
>    $ date -d -0days +%Y-%m-%d
>    2016-03-14
> 
>    $ date -d -1days +%Y-%m-%d
>    2016-03-12

When trying to add units of 24 hours (the -1days), only to then display
just a day and not an hour, it's best to start from noon rather than
from a time that might be impacted by daylight savings:

# date -d '12:00pm 2014-03-14 -1day' +%Y-%m-%d
2016-03-13

Otherwise, as you discovered, starting at midnight and going 24 hours
across a day with only 23 hours is likely to skip that day.

I'm closing this as not a bug, but feel free to reply with further
questions or comments.

-- 
Eric Blake   eblake redhat com    +1-919-301-3266
Libvirt virtualization library http://libvirt.org

Subject: Daylight Savings Time Bug in Date
From: Sarah Corriher <[email-masked]>
To: [email-masked]
Date: Mon, 14 Mar 2016 01:24:40 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

We detected a bug in the date program, which correlates to the daylight 
savings time change. A day disappeared from the date program between 
12:00 AM and 1:00 AM on 3/14/16. The date program began working as 
expected immediately after 1:00 AM. Here is the bizarre output that I 
got for basic commands on 3/14/16:

    $ date -d -0days +%Y-%m-%d
    2016-03-14

    $ date -d -1days +%Y-%m-%d
    2016-03-12

Notice that I was unable to obtain the expected output of 2016-03-13 for 
the day prior. I was able to reproduce this using version 8.13 on 
Debian, and 8.21 on Mint.

-- 
Sarah C. Corriher
Co-author of "Defy Your Doctor and Be Healed"
336-528-4120
http://HealthWyze.org

We're Health Wyze. Have you told your friends about us?